/** SkyFox_game v0.950**/

/*
*   This software is provided 'as-is', without any express or implied warranty.
*   In no event will the authors be held liable for any damages arising from
*   the use of this software.
*
*   Permission is granted to anyone to use this software for any purpose,
*   including commercial applications, and to alter it and redistribute it freely,
*   subject to the following restrictions:
*
*   1. The origin of this software must not be misrepresented; you must not claim
*   that you wrote the original software. If you use this software in a product, an
*   acknowledgment in the product documentation would be appreciated but is not required.
*
*   2. Altered source versions must be plainly marked as such, and must not be
*   misrepresented as being the original software.
*
*   3. This notice may not be removed or altered from any source distribution.
*/

#ifndef lint
///__COPYRIGHT( "@(#) 2011\n Sidorov Andre (Sky-Fox) \n");
#endif /* not lint */


//include Standard System Include Files...
#include <iostream>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>

#include "include\irrlicht\irrlicht.h"      //  
#include "include\IrrOde\IrrOde\IrrODE.h"   // ()
//#include "include\irrKlang\irrKlang.h"      //

/*    IrrLicht*/
using namespace irr;

/*core        vectors, planes, arrays, lists  . .*/
using namespace core;

/*scene       :   (Mesh),    (  octrees  billboards)*/
using namespace scene;

/*video          .  2d  3d   .*/
using namespace video;

/*io     /,   :    ,   zip , xml ,*/
using namespace io;

/*gui           GUI.*/
using namespace gui;

/*   */
//using namespace irrklang;

/*     IrrODE*/
using namespace ode;

/*
//  CSettings
//      IrrOde
//   (BrainSaw)  IrrOde
//      
*/
#include "CSettings.h"



/*TODO Globall  */

/* ,     :-)*/
struct Sky_Car{
vector3df Car_Position;                                         /*   */
vector3df Car_Rotation;                                         /*   */
vector3df Car_Scale;                                            /*   */
bool Damage;
// 
CIrrOdeBody *Car_OdeBody;                                       /*   ()*/
IAnimatedMesh *Car_AnimatedMesh;                                /*    */
IAnimatedMeshSceneNode *Car_AnimatedMeshSceneNode;              /*     */
CIrrOdeGeomBox *Car_OdeGeom;                                     /*   -()*/
// 
CIrrOdeBody *Car_d_OdeBody;                                     /*   ()*/
IAnimatedMesh *Car_d_AnimatedMesh;                              /*    */
IAnimatedMeshSceneNode *Car_d_AnimatedMeshSceneNode;            /*     */
CIrrOdeGeomBox *Car_d_OdeGeom;                                   /*   -()*/
//o 1
CIrrOdeBody *Car_whell_1_OdeBody;                               /*   ()*/
IAnimatedMesh *Car_whell_1_AnimatedMesh;                        /*    */
IAnimatedMeshSceneNode *Car_whell_1_AnimatedMeshSceneNode;      /*     */
CIrrOdeGeomSphere *Car_whell_1_OdeGeom;                          /*   -()*/
CIrrOdeJointHinge2 *test_1_JointHinge;
//o 2
CIrrOdeBody *Car_whell_2_OdeBody;                               /*   ()*/
IAnimatedMesh *Car_whell_2_AnimatedMesh;                        /*    */
IAnimatedMeshSceneNode *Car_whell_2_AnimatedMeshSceneNode;      /*     */
CIrrOdeGeomSphere *Car_whell_2_OdeGeom;                          /*   -()*/
CIrrOdeJointHinge2 *test_2_JointHinge;
//o 3
CIrrOdeBody *Car_whell_3_OdeBody;                               /*   ()*/
IAnimatedMesh *Car_whell_3_AnimatedMesh;                        /*    */
IAnimatedMeshSceneNode *Car_whell_3_AnimatedMeshSceneNode;      /*     */
CIrrOdeGeomSphere *Car_whell_3_OdeGeom;                          /*   -()*/
CIrrOdeJointHinge *test_3_JointHinge;
//o 4
CIrrOdeBody *Car_whell_4_OdeBody;                               /*   ()*/
IAnimatedMesh *Car_whell_4_AnimatedMesh;                        /*    */
IAnimatedMeshSceneNode *Car_whell_4_AnimatedMeshSceneNode;      /*     */
CIrrOdeGeomSphere *Car_whell_4_OdeGeom;                          /*   -()*/
CIrrOdeJointHinge *test_4_JointHinge;
};


/*TODO Main*/
int main(int argc, char** argv) {

/////////////////////////////////////////////////////////////////////////
//    
//
// CSettings.h   -   
// CSettings.cpp -  
//
/////////////////////////////////////////////////////////////////////////
  CSettings *pSettings=new CSettings("data/Settings.xml",L"Graphics Settings",SColor(0x00,0x21,0xAD,0x00));
  pSettings->addValidDriver(L"Direct3D9",EDT_DIRECT3D9);
  pSettings->addValidDriver(L"OpenGL",EDT_OPENGL);
  pSettings->setMinResolution(dimension2du(320,200));
//  pSettings->setMinResolution(dimension2du(800,600));
//  pSettings->setMinResolution(dimension2du(1440,900));

  u32 iRet=pSettings->run();
  if (iRet==2) {
    delete pSettings;
    return 0;
  }
  //now create the Irrlicht device from the chosen options
  IrrlichtDevice *device=pSettings->createDeviceFromSettings();

/////////////////////////////////////////////////////////////////////////

  device->setWindowCaption(L"Sky-Fox Game");

  ISceneManager *smgr = device->getSceneManager();
  IVideoDriver* driver = device->getVideoDriver();
  IGUIEnvironment* guienv = device->getGUIEnvironment();

  device->getFileSystem()->addFolderFileArchive("data/");

//
scene::ISceneNode* SkyBox=0;
SkyBox = smgr->addSkyBoxSceneNode(
driver->getTexture("data/sphere1.jpg"),
driver->getTexture("data/sphere1.jpg"),
driver->getTexture("data/sphere1.jpg"),
driver->getTexture("data/sphere1.jpg"),
driver->getTexture("data/sphere1.jpg"),
driver->getTexture("data/sphere1.jpg"));


//ODE
CIrrOdeSceneNodeFactory cFactory(smgr);
smgr->registerSceneNodeFactory(&cFactory);
//set the scene manager
CIrrOdeManager::getSharedInstance()->install(device);
//init the ODE
CIrrOdeManager::getSharedInstance()->initODE();


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //fadd a worldNode
  ISceneNode *pNode1=smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_WORLD_NAME),smgr->getRootSceneNode());
  CIrrOdeWorld *worldNode=reinterpret_cast<CIrrOdeWorld *>(pNode1);
  worldNode->setGravity(vector3df(0,-10.0f,0));
  worldNode->setMaxAngularSpeed(1);

  scene::IAnimatedMesh *mesh=smgr->getMesh("map.bsp");

    if (mesh) {
      //for optimization we use an octree scene node...
      scene::IMeshSceneNode *node=smgr->addOctreeSceneNode(mesh,worldNode); //->addAnimatedMeshSceneNode(mesh,worldNode);
      if (node) {
        node->setPosition(core::vector3df(0,-50,0));
        //... and for detailed collision detection we use a trimesh.
        CIrrOdeGeomTrimesh *pTri=reinterpret_cast<CIrrOdeGeomTrimesh *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_GEOM_TRIMESH_NAME),node));

        //One important thing: a static trimesh has one surface for every meshbuffer (aka "material") of the parent scene node
        for (u32 j=0; j<pTri->getSurfaceParametersCount(); j++) {
                pTri->setCollide(true);
                pTri->getSurfaceParameters(j)->setUseDefined(false);
                pTri->getSurfaceParameters(j)->setModeMu2(false);
                pTri->getSurfaceParameters(j)->setModeFDir1(false);
                pTri->getSurfaceParameters(j)->setModeBounce(true);
                pTri->getSurfaceParameters(j)->setModeSoftERP(false);
                pTri->getSurfaceParameters(j)->setModeSoftCFM(false);
                pTri->getSurfaceParameters(j)->setModeMotion1(false);
                pTri->getSurfaceParameters(j)->setModeMotion2(false);
                pTri->getSurfaceParameters(j)->setModeMotionN(false);
                pTri->getSurfaceParameters(j)->setModeSlip1(false);
                pTri->getSurfaceParameters(j)->setModeSlip2(false);
                pTri->getSurfaceParameters(j)->setModeApprox1_1(false);
                pTri->getSurfaceParameters(j)->setModeApprox1_2(false);

                pTri->getSurfaceParameters(j)->setMu(100.000000);
                pTri->getSurfaceParameters(j)->setMu2(0.000000);
                pTri->getSurfaceParameters(j)->setBounce(0.200000);
                pTri->getSurfaceParameters(j)->setBounceVel(0.000000);
                pTri->getSurfaceParameters(j)->setSoftErp(0.000000);
                pTri->getSurfaceParameters(j)->setSoftCfm(0.000000);
                pTri->getSurfaceParameters(j)->setMotion1(0.000000);
                pTri->getSurfaceParameters(j)->setMotion2(0.000000);
                pTri->getSurfaceParameters(j)->setMotionN(0.000000);
                pTri->getSurfaceParameters(j)->setSlip1(0.000000);
                pTri->getSurfaceParameters(j)->setSlip2(0.000000);


        }

        pTri->drop();
      }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Sky_Car MyCar;
    MyCar.Car_Position=vector3df(0.0f,-100.0f,0.0f);
    MyCar.Car_Scale=vector3df(30.0f,30.0f,30.0f);
    MyCar.Damage=0;

MyCar.Car_OdeBody=reinterpret_cast<CIrrOdeBody *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_BODY_NAME),worldNode));
//MyCar.Car_OdeBody->setPosition(MyCar.Car_Position);

MyCar.Car_AnimatedMesh=smgr->getMesh("data/car_c.x");

MyCar.Car_AnimatedMeshSceneNode=smgr->addAnimatedMeshSceneNode(MyCar.Car_AnimatedMesh,MyCar.Car_OdeBody);

    MyCar.Car_AnimatedMeshSceneNode->setMaterialTexture(0,driver->getTexture("data/car_c_c1.tga"));
    MyCar.Car_AnimatedMeshSceneNode->setMaterialFlag(EMF_LIGHTING,false);
    MyCar.Car_AnimatedMeshSceneNode->setScale(MyCar.Car_Scale);
    MyCar.Car_AnimatedMeshSceneNode->setVisible(!MyCar.Damage);
    MyCar.Car_AnimatedMeshSceneNode->setPosition(MyCar.Car_Position);

MyCar.Car_OdeGeom=reinterpret_cast<CIrrOdeGeomBox *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_GEOM_BOX_NAME),MyCar.Car_AnimatedMeshSceneNode));
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setUseDefined(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeMu2(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeFDir1(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeBounce(true);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeSoftERP(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeSoftCFM(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeMotion1(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeMotion2(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeMotionN(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeSlip1(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeSlip2(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeApprox1_1(false);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setModeApprox1_2(false);

    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setMu(300.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setMu2(200.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setBounce(0.200000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setBounceVel(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setSoftErp(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setSoftCfm(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setMotion1(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setMotion2(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setMotionN(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setSlip1(0.000000);
    MyCar.Car_OdeGeom->getSurfaceParameters(0)->setSlip2(0.000000);
    MyCar.Car_OdeGeom->setMassTotal(1.000000);

    MyCar.Car_OdeGeom->drop();

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

MyCar.Car_d_AnimatedMesh=smgr->getMesh("data/car_d.x");

MyCar.Car_d_AnimatedMeshSceneNode=smgr->addAnimatedMeshSceneNode(MyCar.Car_d_AnimatedMesh,MyCar.Car_OdeBody);
    MyCar.Car_d_AnimatedMeshSceneNode->setMaterialTexture(0,driver->getTexture("data/car_d_c1.tga"));
    MyCar.Car_d_AnimatedMeshSceneNode->setMaterialFlag(EMF_LIGHTING,false);
    MyCar.Car_d_AnimatedMeshSceneNode->setScale(MyCar.Car_Scale);
    MyCar.Car_d_AnimatedMeshSceneNode->setVisible(MyCar.Damage);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
MyCar.test_1_JointHinge=reinterpret_cast<CIrrOdeJointHinge2 *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_JOINT_HINGE2_NAME),MyCar.Car_OdeBody));

MyCar.Car_whell_1_OdeBody=reinterpret_cast<CIrrOdeBody *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_BODY_NAME),MyCar.test_1_JointHinge));
MyCar.Car_whell_1_AnimatedMesh=smgr->getMesh("data/whell.x");

MyCar.Car_whell_1_AnimatedMeshSceneNode=smgr->addAnimatedMeshSceneNode(MyCar.Car_whell_1_AnimatedMesh,MyCar.Car_whell_1_OdeBody);
    MyCar.Car_whell_1_AnimatedMeshSceneNode->setMaterialTexture(0,driver->getTexture("data/whell.tga"));
    MyCar.Car_whell_1_AnimatedMeshSceneNode->setMaterialFlag(EMF_LIGHTING,false);
    MyCar.Car_whell_1_AnimatedMeshSceneNode->setScale(MyCar.Car_Scale);
    MyCar.Car_whell_1_AnimatedMeshSceneNode->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+(MyCar.Car_Scale * (MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee1")->getPosition())));

MyCar.Car_whell_1_OdeGeom=reinterpret_cast<CIrrOdeGeomSphere *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_GEOM_SPHERE_NAME),MyCar.Car_whell_1_AnimatedMeshSceneNode));
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setUseDefined(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeMu2(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeFDir1(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeBounce(true);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeSoftERP(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeSoftCFM(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeMotion1(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeMotion2(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeMotionN(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeSlip1(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeSlip2(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeApprox1_1(false);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setModeApprox1_2(false);

    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setMu(200.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setMu2(125.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setBounce(0.250000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setBounceVel(0.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setSoftErp(0.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setSoftCfm(0.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setMotion1(0.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setMotion2(0.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setMotionN(0.000000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setSlip1(0.250000);
    MyCar.Car_whell_1_OdeGeom->getSurfaceParameters(0)->setSlip2(0.250000);
    MyCar.Car_whell_1_OdeGeom->setMassTotal(0.010000);

    MyCar.Car_whell_1_OdeGeom->drop();


MyCar.test_1_JointHinge->setBody2(MyCar.Car_whell_1_OdeBody);
MyCar.test_1_JointHinge->setHingeAxis1(vector3df(0,1,0));
MyCar.test_1_JointHinge->setHingeAxis2(vector3df(1,0,0));
MyCar.test_1_JointHinge->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+(MyCar.Car_Scale * (MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee1")->getPosition())));



CIrrOdeMotor * test_1_OdeMotor=reinterpret_cast<CIrrOdeMotor *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_MOTOR_NAME),MyCar.Car_OdeBody));
test_1_OdeMotor->setJoint(MyCar.test_1_JointHinge);
test_1_OdeMotor->setAutomaticCulling(EAC_BOX);
test_1_OdeMotor->setAxis(0);
test_1_OdeMotor->setForce(500.000000);
test_1_OdeMotor->setVelocity(1.000000);
test_1_OdeMotor->setEnabled(true);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
MyCar.test_2_JointHinge=reinterpret_cast<CIrrOdeJointHinge2 *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_JOINT_HINGE2_NAME),MyCar.Car_OdeBody));

MyCar.Car_whell_2_OdeBody=reinterpret_cast<CIrrOdeBody *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_BODY_NAME),MyCar.test_2_JointHinge));
MyCar.Car_whell_2_AnimatedMesh=smgr->getMesh("data/whell.x");

MyCar.Car_whell_2_AnimatedMeshSceneNode=smgr->addAnimatedMeshSceneNode(MyCar.Car_whell_1_AnimatedMesh,MyCar.Car_whell_2_OdeBody);
    MyCar.Car_whell_2_AnimatedMeshSceneNode->setMaterialTexture(0,driver->getTexture("data/whell.tga"));
    MyCar.Car_whell_2_AnimatedMeshSceneNode->setMaterialFlag(EMF_LIGHTING,false);
    MyCar.Car_whell_2_AnimatedMeshSceneNode->setScale(MyCar.Car_Scale);
    MyCar.Car_whell_2_AnimatedMeshSceneNode->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+((MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee2")->getPosition())*MyCar.Car_Scale));

MyCar.Car_whell_2_OdeGeom=reinterpret_cast<CIrrOdeGeomSphere *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_GEOM_SPHERE_NAME),MyCar.Car_whell_2_AnimatedMeshSceneNode));
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setUseDefined(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeMu2(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeFDir1(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeBounce(true);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeSoftERP(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeSoftCFM(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeMotion1(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeMotion2(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeMotionN(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeSlip1(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeSlip2(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeApprox1_1(false);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setModeApprox1_2(false);

    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setMu(200.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setMu2(125.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setBounce(0.250000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setBounceVel(0.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setSoftErp(0.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setSoftCfm(0.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setMotion1(0.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setMotion2(0.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setMotionN(0.000000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setSlip1(0.250000);
    MyCar.Car_whell_2_OdeGeom->getSurfaceParameters(0)->setSlip2(0.250000);
    MyCar.Car_whell_2_OdeGeom->setMassTotal(0.010000);

    MyCar.Car_whell_2_OdeGeom->drop();


MyCar.test_2_JointHinge->setBody2(MyCar.Car_whell_2_OdeBody);
MyCar.test_2_JointHinge->setHingeAxis1(vector3df(0,1,0));
MyCar.test_2_JointHinge->setHingeAxis2(vector3df(1,0,0));
MyCar.test_2_JointHinge->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+((MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee2")->getPosition())*MyCar.Car_Scale));


CIrrOdeMotor * test_2_OdeMotor=reinterpret_cast<CIrrOdeMotor *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_MOTOR_NAME),MyCar.Car_OdeBody));
test_2_OdeMotor->setJoint(MyCar.test_2_JointHinge);
test_2_OdeMotor->setAutomaticCulling(EAC_BOX);
test_2_OdeMotor->setAxis(0);
test_2_OdeMotor->setForce(500.000000);
test_2_OdeMotor->setVelocity(1.000000);
test_2_OdeMotor->setEnabled(true);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
MyCar.test_3_JointHinge=reinterpret_cast<CIrrOdeJointHinge *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_JOINT_HINGE_NAME),MyCar.Car_OdeBody));

MyCar.Car_whell_3_OdeBody=reinterpret_cast<CIrrOdeBody *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_BODY_NAME),MyCar.test_3_JointHinge));
MyCar.Car_whell_3_AnimatedMesh=smgr->getMesh("data/whell.x");

MyCar.Car_whell_3_AnimatedMeshSceneNode=smgr->addAnimatedMeshSceneNode(MyCar.Car_whell_1_AnimatedMesh,MyCar.Car_whell_3_OdeBody);
    MyCar.Car_whell_3_AnimatedMeshSceneNode->setMaterialTexture(0,driver->getTexture("data/whell.tga"));
    MyCar.Car_whell_3_AnimatedMeshSceneNode->setMaterialFlag(EMF_LIGHTING,false);
    MyCar.Car_whell_3_AnimatedMeshSceneNode->setScale(MyCar.Car_Scale);
    MyCar.Car_whell_3_AnimatedMeshSceneNode->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+((MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee3")->getPosition())*MyCar.Car_Scale));

MyCar.Car_whell_3_OdeGeom=reinterpret_cast<CIrrOdeGeomSphere *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_GEOM_SPHERE_NAME),MyCar.Car_whell_3_AnimatedMeshSceneNode));
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setUseDefined(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeMu2(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeFDir1(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeBounce(true);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeSoftERP(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeSoftCFM(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeMotion1(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeMotion2(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeMotionN(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeSlip1(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeSlip2(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeApprox1_1(false);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setModeApprox1_2(false);

    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setMu(200.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setMu2(125.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setBounce(0.250000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setBounceVel(0.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setSoftErp(0.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setSoftCfm(0.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setMotion1(0.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setMotion2(0.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setMotionN(0.000000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setSlip1(0.250000);
    MyCar.Car_whell_3_OdeGeom->getSurfaceParameters(0)->setSlip2(0.250000);
    MyCar.Car_whell_3_OdeGeom->setMassTotal(0.010000);

    MyCar.Car_whell_3_OdeGeom->drop();


MyCar.test_3_JointHinge->setBody2(MyCar.Car_whell_3_OdeBody);
MyCar.test_3_JointHinge->setHingeAxis(vector3df(1,0,0));
MyCar.test_3_JointHinge->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+((MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee3")->getPosition())*MyCar.Car_Scale));

CIrrOdeMotor * test_3_OdeMotor=reinterpret_cast<CIrrOdeMotor *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_MOTOR_NAME),MyCar.Car_OdeBody));
test_3_OdeMotor->setJoint(MyCar.test_3_JointHinge);
test_3_OdeMotor->setAutomaticCulling(EAC_BOX);
test_3_OdeMotor->setAxis(0);
test_3_OdeMotor->setForce(500.000000);
test_3_OdeMotor->setVelocity(1.000000);
test_3_OdeMotor->setEnabled(true);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
MyCar.test_4_JointHinge=reinterpret_cast<CIrrOdeJointHinge *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_JOINT_HINGE_NAME),MyCar.Car_OdeBody));

MyCar.Car_whell_4_OdeBody=reinterpret_cast<CIrrOdeBody *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_BODY_NAME),MyCar.test_4_JointHinge));
MyCar.Car_whell_4_AnimatedMesh=smgr->getMesh("data/whell.x");

MyCar.Car_whell_4_AnimatedMeshSceneNode=smgr->addAnimatedMeshSceneNode(MyCar.Car_whell_1_AnimatedMesh,MyCar.Car_whell_4_OdeBody);
    MyCar.Car_whell_4_AnimatedMeshSceneNode->setMaterialTexture(0,driver->getTexture("data/whell.tga"));
    MyCar.Car_whell_4_AnimatedMeshSceneNode->setMaterialFlag(EMF_LIGHTING,false);
    MyCar.Car_whell_4_AnimatedMeshSceneNode->setScale(MyCar.Car_Scale);
    MyCar.Car_whell_4_AnimatedMeshSceneNode->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+((MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee4")->getPosition())*MyCar.Car_Scale));

MyCar.Car_whell_4_OdeGeom=reinterpret_cast<CIrrOdeGeomSphere *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_GEOM_SPHERE_NAME),MyCar.Car_whell_4_AnimatedMeshSceneNode));
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setUseDefined(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeMu2(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeFDir1(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeBounce(true);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeSoftERP(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeSoftCFM(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeMotion1(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeMotion2(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeMotionN(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeSlip1(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeSlip2(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeApprox1_1(false);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setModeApprox1_2(false);

    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setMu(200.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setMu2(125.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setBounce(0.250000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setBounceVel(0.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setSoftErp(0.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setSoftCfm(0.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setMotion1(0.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setMotion2(0.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setMotionN(0.000000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setSlip1(0.250000);
    MyCar.Car_whell_4_OdeGeom->getSurfaceParameters(0)->setSlip2(0.250000);
    MyCar.Car_whell_4_OdeGeom->setMassTotal(0.010000);

    MyCar.Car_whell_4_OdeGeom->drop();

MyCar.test_4_JointHinge->setBody2(MyCar.Car_whell_4_OdeBody);
MyCar.test_4_JointHinge->setHingeAxis(vector3df(1,0,0));
MyCar.test_4_JointHinge->setPosition((MyCar.Car_AnimatedMeshSceneNode->getPosition())+((MyCar.Car_AnimatedMeshSceneNode->getJointNode("b_whee4")->getPosition())*MyCar.Car_Scale));

CIrrOdeMotor * test_4_OdeMotor=reinterpret_cast<CIrrOdeMotor *>(smgr->addSceneNode(CIrrOdeSceneNode::nodeNameToC8(IRR_ODE_MOTOR_NAME),MyCar.Car_OdeBody));
test_4_OdeMotor->setJoint(MyCar.test_4_JointHinge);
test_4_OdeMotor->setAutomaticCulling(EAC_BOX);
test_4_OdeMotor->setAxis(0);
test_4_OdeMotor->setForce(500.000000);
test_4_OdeMotor->setVelocity(1.000000);
test_4_OdeMotor->setEnabled(true);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
worldNode->initPhysics();

ICameraSceneNode *cam=smgr->addCameraSceneNodeFPS();
//cam=smgr->addCameraSceneNodeMaya();
cam->setPosition(core::vector3df(-20.0f, 15.0f, -20.0f));
device->getCursorControl()->setVisible(false);
cam->setFarValue(50000.0f);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  while(device->run()) {
    driver->beginScene(true, true, SColor(0,200,200,200));

    smgr->drawAll();
    guienv->drawAll();
    device->getGUIEnvironment()->drawAll();
    driver->endScene();
    CIrrOdeManager::getSharedInstance()->step();
  }

  device->drop();
  return 0;
}
